var em = window.opener.em;

em.brain = {
  onLoad:function(){
    try {
      if("arguments" in window && window.arguments.length > 0) {
        em.el('emMode', document).selectedIndex = window.arguments[0].wrappedJSObject.mode;
        if (window.arguments[0].wrappedJSObject.item) {
          if (window.arguments[0].wrappedJSObject.item=='first') em.el('emDList', document).selectedIndex = 0;
          else if (window.arguments[0].wrappedJSObject.item) em.el('emDList', document).selectedItem = document.getElementById(window.arguments[0].wrappedJSObject.item);
        }
      }
      if (!window.arguments[0].wrappedJSObject.item) em.brain.paint();
      window.arguments[0].wrappedJSObject.item = false;
    } catch(e) { if (em.DEBUG) em.alert(e, 'emBug0:'); }
  },
  join:function(){ return em.el('emDJoin', document).checked; },
  refresh:function(onlyMenus) {
    if (!onlyMenus) {
      em.el('emButtonRefresh', document).disabled = true;
      em.brain.paint();
    }
    else {
      em.el('emButtonRefresh', document).disabled = (em.el('emMode', document).selectedIndex==0);
      em.brain.changeDateSkip = (em.el('emMode', document).selectedIndex==0);
    }
    var emDListi = em.el('emDList', document).selectedIndex;
    em.el('emMode', document).selectedIndex = em.el('emMode', document).selectedIndex;
    if (emDListi>=em.el('emDList', document).children.length) emDListi = em.el('emDList', document).children.length - 1;
    em.el('emDList', document).selectedIndex = emDListi;
  },
  changeModeSkip:false,
  changeMode:function(m,str){
    try {
      if (!em.brain.changeModeSkip) { em.brain.changeModeSkip = true; return; }
      document.title = em.addon().name+' - '+str;
      em.el('emDJoin', document).setAttribute('disabled', !m);
      var l = document.getElementById('emDList');
      em.clean(l);
      var t = em.sql.query({
        sqlitem:'brainList',
        sqlfunc:'select'+em.M[m],
        max:-1
      });
      var joined = [em.brain.join()], els = {el:{},co:{}};
      if (!t.success || !t.total) {
        var d = em.elc('listitem', document);
        em.attr(d, 'label', '- no records found -' );
        em.attr(d, 'disabled', true );
        em.add(l, d);
      } else for(var i=0;i<t.total;i++) {
        var date = new Date(t.data[i].date);
        var date = new Date(date.getFullYear(),date.getMonth(),date.getDate());
        if (m&&joined[0]) {
          els.co['el'+t.data[i].date] = (els.co['el'+t.data[i].date]||0)+1;
          if (joined.indexOf(t.data[i].date)!=-1) {
            if (els.el['el'+t.data[i].date]) {
              em.attr(els.el['el'+t.data[i].date], 'label', (date.getDate()<10?'  ':'')+em.ordinal(date.getDate())+' of '+em.month(date)+', '+date.getFullYear()+(m?'  ('+els.co['el'+date.getTime()]+')':''));
              if (m&&window.arguments[0].wrappedJSObject.item&&t.data[i].id==window.arguments[0].wrappedJSObject.item)
                window.arguments[0].wrappedJSObject.item=els.el['el'+t.data[i].date].getAttribute('id');
            }
            continue;
          }
        }
        var d = em.elc('listitem', document);
        if (m&&joined[0]) {
          joined.push(t.data[i].date);
          els.el['el'+t.data[i].date] = d;
        }
        em.attr(d, 'label', (date.getDate()<10?'  ':'')+em.ordinal(date.getDate())+' of '+em.month(date)+', '+date.getFullYear()+((!m||(m&&joined[0]))?'  ('+(!m?t.data[i].total:1)+')':''));
        em.attr(d, 'id', t.data[i].id);
        em.attr(d, 'ref', t.data[i].ref||false);
        em.attr(d, 'date', t.data[i].date);
        /*em.attr(d, 'cost', t.data[i].cost||false);
        em.attr(d, 'prize', t.data[i].prize||false);*/
        em.attr(d, 'ball', m!=1?t.data[i].ball:false);
        em.attr(d, 'star', m!=1?t.data[i].star:false);
        em.attr(d, 'roll', m!=1?t.data[i].roll:0);
        em.attr(d, 'prizes', t.data[i].prizes||'{}' );
        em.attr(d, 'mode', m||'0');
        em.add(l, d);
      }
      document.title = document.title + ' ('+(t&&t.success?t.total:0)+')';
    } catch(e) { if (em.DEBUG) em.alert(e, 'emBug1:'); }
  },
  changeDateSkip:true,
  changeDate:function(el){
    if (!em.brain.changeDateSkip) { em.brain.changeDateSkip = true; return; }
    em.el('emButtonRefresh', document).disabled = true;
    if (el.getAttribute('disabled')) return;
    try {
      var o = {};
      for(var i=0;i<el.attributes.length;i++) o[el.attributes[i].name] = el.attributes[i].value;
      o.mode = parseInt(o.mode);
      o.date = new Date(parseInt(o.date));
      o.date = new Date(o.date.getFullYear(),o.date.getMonth(),o.date.getDate());
      o.ball = (o.ball)?o.ball.match(/\d+/g).sort(function(a,b){return parseInt(a)-parseInt(b)}):[];
      o.star = (o.star)?o.star.match(/\d+/g).sort(function(a,b){return parseInt(a)-parseInt(b)}):[];
      /*o.cost = parseFloat(o.cost||0).toFixed(2);
      o.prize = parseFloat(o.prize||0).toFixed(2);*/
      o.prizes = em.CCIN('@mozilla.org/dom/json;1', 'nsIJSON').decode(o.prizes);
      if (!o.mode) o.ref = o.id = Math.round((o.id-em.D.first)/em.D.week)+1;
      else if (o.ref) o.ref = Math.round((o.ref-em.D.first)/em.D.week)+1;
      em.brain.paint(o);
    } catch(e) { if (em.DEBUG) em.alert(e, 'emBug2:'); }
  },
  paint:function(o){
    if (!o) o = {};
    try {
      var idDate, refDate;
      em.el('emBrainTabAbout', document).setAttribute('disabled', (!o.id||!o.ref));
      em.el('emGridAbout', document).hidden = (!o.id||!o.ref);
      em.el('emTList', document).hidden = (!o.id);
      if (!o.ref&&em.el('emTabs', document).selectedItem==em.el('emBrainTabAbout', document)) em.el('emTabs', document).selectedItem = em.el('emBrainTabMain', document);
      if (o.id) {
        idDate = em.day(o.date)+' '+em.month(o.date)+' '+em.ordinal(o.date.getDate())+' '+o.date.getFullYear();
        refDate = (o.ref?em.ordinal(o.ref):em.ordinal((o.date.getTime()-em.D.first)/em.D.week));
        em.el('emBrainTabAbout', document).setAttribute('label', 'Details about the '+refDate+' draw..');
        o.ref = 'The '+refDate+' EuroMillions draw '+((o.ref)?'took place on '+idDate+' at 10pm CET (9pm UK time) and the result was as above:':'will take place on '+idDate+' at 10pm CET (9pm UK time).');
      } else em.el('emBrainTabAbout', document).setAttribute('label', 'Details about..');
      var joined = em.brain.join();
      em.text('emBrainTitle', o.ref||'', document);
      em.el('emBrainRollover', document).hidden = (!o.roll);
      em.el('emBrainRolloverErr', document).hidden = (typeof o.prizes.p12 != 'undefined'||o.date.getTime()<em.D.margin);
      em.el('emTListCaption', document).setAttribute('label', o.id?(joined?'All your ':'')+(o.mode?em.M[o.mode]+' ':'')+'Ticket'+(em.brain.join()?'s':' #'+o.id)+' for '+idDate+':':'');
      for(var i=0;i<(o.id&&o.mode!=1?o.ball.length:5);i++) em.attr(em.el('ball-'+i, document), 'src', o.id?'chrome://euromillions/skin/n/'+(o.mode!=1?'b':'c')+(o.mode!=1?(o.ball[i]<10?'0':'')+o.ball[i]:'00')+'.'+'gif':'chrome://euromillions/skin/fake.img');
      for(i=0;i<(o.id&&o.mode!=1?o.star.length:2);i++) em.attr(em.el('star-'+i, document), 'src', o.id?'chrome://euromillions/skin/n/'+(o.mode!=1?'b':'c')+'e'+(o.mode!=1?(o.star[i]<10?'0':'')+o.star[i]:'00')+'.'+'gif':'chrome://euromillions/skin/fake.img');
      var ids = [], idsm = false;
      if (o.id) {
        var r = em.sql.query({
          sqlitem:'brainResult',
          sqlfunc:'select'+em.M[o.mode],
          date:o.date.getTime(),
          id:(!joined&&o.mode?o.id+'':'%')
        });
        if (!r.success || !r.total) {
          ids.push(o.id);
          em.el('emTListLabel', document).hidden = false;
          em.el('emTListGrid', document).hidden = true;
        } else {
          em.el('emTListLabel', document).hidden = true;
          em.el('emTListGrid', document).hidden = false;
          var p = em.clean('emTListGridRows', document);
          for(i=0;i<r.total;i++) {
            if (o.mode&&joined) {
              if (ids.length<4) ids.push(r.data[i].id);
              else if (!idsm) idsm = true;
            }
            em.brain.paintTicket(p, o, r.data[i])
          }
        }
        em.brain.paintAbout(o);
      }
      em.el('emBrainTabMain', document).setAttribute('label', (o.id?(o.mode?'Ticket'+(o.mode&&joined&&ids.length>1?'s':''):'Result')+' #'+(o.mode&&joined?ids.join(', #'):o.id)+(o.mode&&joined&&idsm&&ids.length>1?'.. and more':''):'<-- Select a date..'));
    } catch(e) { if (em.DEBUG) em.alert(e, 'emBug3:'); }
  },
  paintTicket:function(p, o, r){
    try {
      var h = em.elc('row', document);
      var m = em.elc('button', document);
      em.attr(m, 'label', 'Ticket #'+r.id+': ' );
      em.attr(m, 'type', 'menu' );
      var mp = em.elc('menupopup', document);
      var ma = em.elc('menuitem', document);
      var maa = em.elc('menuitem', document);
      var mb = em.elc('menuseparator', document);
      var mc = em.elc('menuitem', document);
      em.attr(ma, 'label', 'Edit' );
      em.attr(ma, 'oncommand', 'em.brain.editTicket(\''+em.CCIN('@mozilla.org/dom/json;1', 'nsIJSON').encode(r)+'\');' );
      em.attr(maa, 'label', 'Undo Check' );
      em.attr(maa, 'oncommand', 'em.brain.undoTicket(this, this.parentNode.parentNode.parentNode, '+r.id+', \''+em.CCIN('@mozilla.org/dom/json;1', 'nsIJSON').encode(o)+'\');' );
      em.attr(maa, 'disabled', (r.prize=='pending') );
      em.attr(mc, 'label', 'Delete' );
      em.attr(mc, 'oncommand', 'em.brain.deleteTicket('+r.id+');' );
      em.add(mp, ma);
      em.add(mp, maa);
      em.add(mp, mb);
      em.add(mp, mc);
      em.add(m, mp);
      em.add(h, m);
      var hh = em.elc('hbox', document);
      em.attr(hh, 'style', 'padding:3px 0px;' );
      var bs = [r.ball.match(/\d+/g),r.star.match(/\d+/g)];
      for(var j=0;j<bs.length;j++)
        for(var jj=0;jj<bs[j].length;jj++) {
          var im = em.elc('image', document);
          em.attr(im, 'style', 'margin:3px;width:17px;height:17px;' );
          em.attr(im, 'n', bs[j][jj] );
          em.attr(im, 'src', 'chrome://euromillions/skin/n/'+((r.prize!='pending'&&o[(j?'star':'ball')].indexOf(bs[j][jj])!=-1)?'p':'')+(j?'e':'')+(bs[j][jj]<10?'0':'')+bs[j][jj]+'.'+'gif' );
          em.add(hh, im);
        }
      em.add(h, hh);
      var la = em.elc('label', document);
      em.attr(la, 'value', r.cost+' '+em.prefs.getCharPref('money.symbol') );
      em.attr(la, 'hidden', !em.prefs.getBoolPref('result.showcost') );
      em.attr(la, 'style', 'padding-top:7px;' );
      em.add(h, la);
      if (o.mode==2||!o.mode&&r.prize=='pending') {
        var la = em.elc('button', document);
        em.attr(la, 'label','Check!' );
        em.attr(la, 'oncommand','em.brain.checkTicket(this.parentNode, '+r.id+', \''+em.CCIN('@mozilla.org/dom/json;1', 'nsIJSON').encode(o)+'\');' );
        em.add(h, la);
      } else {
        var la = em.elc('label', document);
        em.attr(la, 'value', r.prize=='pending'?'Pending..':((r.prize==-1)?'?':r.prize)+' '+em.prefs.getCharPref('money.symbol') );
        em.attr(la, 'style', 'padding-top:8px;' );
        em.add(h, la);
      }
      
      em.add(p, h);
    } catch(e) { if (em.DEBUG) em.alert(e, 'emBug4:'); }
  
  },
  undoTicket:function(menuitem, row, id, o) {
    menuitem.disabled = true;
    o = em.CCIN('@mozilla.org/dom/json;1', 'nsIJSON').decode(o);
    var c = row.children[1].children;
    for (var i=0;i<c.length;i++) {
      var n = c[i].getAttribute('n');
      c[i].src = 'chrome://euromillions/skin/n/'+(i<c.length-2?'':'e')+(parseInt(n)<10?'0':'')+n+'.'+'gif';
    }
    row.removeChild(row.children[3]);
    var la = em.elc('button', document);
    em.attr(la, 'label','Check!' );
    em.attr(la, 'oncommand','em.brain.checkTicket(this.parentNode, '+id+', \''+em.CCIN('@mozilla.org/dom/json;1', 'nsIJSON').encode(o)+'\');' );
    em.add(row, la);
    em.sql.query({
      sqlitem:'ticket',
      sqlfunc:'updatePrize',
      id:id,
      prize:'pending'
    });
    em.brain.refresh(true);
  },
  checkTicket:function(row, id, o) {
    row.children[0].children[0].children[1].disabled = false;
    o = em.CCIN('@mozilla.org/dom/json;1', 'nsIJSON').decode(o);
    var c = row.children[1].children;
    var match = [0,0];
    for (var i=0;i<c.length;i++) {
      var n = c[i].getAttribute('n');
      if (o[(i<c.length-2?'ball':'star')].indexOf(n)!=-1) {
        c[i].src = 'chrome://euromillions/skin/n/p'+(i<c.length-2?'':'e')+(parseInt(n)<10?'0':'')+n+'.'+'gif';
        match[(i<c.length-2?0:1)]++;
      }
    }
    row.removeChild(row.children[3]);
    var la = em.elc('label', document);
    var prize = ((((o.prizes['p'+match.join('')]||'-1;-1;-1;-1').match(/\-?\d+([\.,\,]\d+)*/g)||['0.00','0.00','0.00'])[em.C.indexOf(em.prefs.getCharPref('money.symbol'))])||'0.00');
    em.attr(la, 'value', ((prize==-1)?'?':prize)+' '+em.prefs.getCharPref('money.symbol') );
    em.attr(la, 'style', 'padding-top:8px;' );
    em.add(row, la);
    em.sql.query({
      sqlitem:'ticket',
      sqlfunc:'updatePrize',
      id:id,
      prize:prize
    });
    em.brain.refresh(true);
  },
  paintAbout:function(o){
    try {
      if (!em.el('emGridAbout', document).hidden) {
        var emC = em.prefs.getCharPref('money.symbol'), emCi = em.C.indexOf(emC);
        var rows = em.clean('emGridContent', document);
        var row = em.elc('row', document);
        var c1 = em.elc('label', document);
        var c2 = em.elc('label', document);
        var c3 = em.elc('label', document);
        em.attr(c1, 'value', 'Prize' );
        em.attr(c2, 'value', 'Value'+' ('+emC+')' );
        em.attr(c3, 'value', 'Winners' );
        em.attr(c1, 'class', 'underlined' );
        em.attr(c2, 'class', 'underlined' );
        em.attr(c3, 'class', 'underlined' );
        em.add(row, c1);
        em.add(row, c2);
        em.add(row, c3);
        em.add(rows, row);
        if (typeof o.prizes.p12 == 'undefined') o.prizes = {"p21":"-1;-1;-1;-1","p12":"-1;-1;-1;-1","p3":"-1;-1;-1;-1","p22":"-1;-1;-1;-1","p31":"-1;-1;-1;-1","p32":"-1;-1;-1;-1","p4":"-1;-1;-1;-1","p41":"-1;-1;-1;-1","p42":"-1;-1;-1;-1","p5":"-1;-1;-1;-1","p1":"-1;-1;-1;-1","p52":"-1;-1;-1;-1"};
        for(i in o.prizes) {
          o.prizes[i] = o.prizes[i].match(/\-?\d+([\.,\,]\d+)*/g);
          var row = em.elc('row', document);
          var m1 = em.elc('label', document);
          var m2 = em.elc('label', document);
          var m3 = em.elc('label', document);
          em.attr(m1, 'value', 'Match '+((i.length==2)?i[1]:i[1]+' and '+i[2]+' Star')+':' );
          em.attr(m2, 'value', (o.prizes[i][emCi]==-1?'?':o.prizes[i][emCi])+' '+emC );
          em.attr(m3, 'value', (o.prizes[i][3]==-1?'?':o.prizes[i][3]) );
          em.attr(m1, 'style', 'text-align:left;width:140px;' );
          em.attr(m2, 'style', 'width:120px;' );
          em.attr(m3, 'style', 'width:120px;' );
          em.add(row, m1);
          em.add(row, m2);
          em.add(row, m3);
          em.add(rows, row);
        }
      }
    } catch(e) { if (em.DEBUG) em.alert(e, 'emBug5:'); }
  },
  editTicket:function(ticket){
    em.addTicket(window, em.brain.refresh, em.CCIN('@mozilla.org/dom/json;1', 'nsIJSON').decode(ticket));
  },
  deleteTicket:function(id){
    if (!em.confirm('The ticket '+id+' will be removed if you agree.', 'Ticket #'+id, window)) return;
    em.sql.query({
      sqlitem:'ticket',
      sqlfunc:'remove',
      id:id
    });
    em.brain.refresh();
  }
};